function [ x, s, Aopt, Iopt, sum_act, avg_inact, time, k, kd, uds, pift, apifu, mpifu, pft, apfu, mpfu, mcountpp] = ckr( Q, d, b, cA, Astart,tol,sil)

% solves: min q'x + (1/2) x'Qx  subject to: x  <= b
% Q is assumed to be symmetric positive definite
tic;
n = length(d);                  % problem size
done = 0;                   % not yet done
countpp = 0;
mcountpp = 0;
uds = 0;
pift = 0;
pft = 0;
apifu = 0;
apfu = 0;
mpifu = 0;
mpfu = 0;

if (cA == 1)
    s = -d - Q*b;
    s_old = s;
    err_d = log10(max(-min(s),1e-99));
    Apre = 1:n;
    Apre = Apre';
    Ipre = [];
    A = find(s>0);
    k = 0;
    kd = 1;
    sum_act = n;
    mfn = 0.5*b'*Q*b+b'*d;
else
    A = Astart;
    k = 0; 
    kd = 0;
    sum_act = 0;
    mfn = 10^50;
end
avg_inact = 0;
delta = 0;
x_h = b;
x = b;
Q_act = Q;
d_act = d;
N = 1:n;
s = zeros(n,1);

while done < 1;                  % while not optimal
     A = sort(A);
     k = k + 1;                  % start a new iteration
     I = ones(n,1);              % compute I, the complement of A
     I(A) = zeros(length(A),1); 
     I = find(I>0);              % complement of A
     I = sort(I);
% solve system KKT(A):
     avg_inact = avg_inact + length(I);
     x_old = x;
     x = b;                      % x( A) = b( A); 
     if isempty(I) == 0;          
         rhs = -d_act(I);
         if isempty(A) == 0;       % update right hand side rhs
           rhs = rhs - Q_act(I,A)*x(A);   
         end; 
         x(I) = Q_act(I,I) \  rhs;   % solve for inactive variables	   
     end;
     err = log10(max(norm(Q*x+d+s,1),1e-99));
     err_p = log10(max(max(x-b),1e-99));
    x_h_old = x_h;
    x_h = min(x,b);
    mfn_old = mfn;
    mfn_old = mfn_old+abs(mfn_old/10^15);
    mfn = 0.5*x_h'*Q*x_h + d'*x_h;
    if(sil ~= 1)
        delmf = mfn - mfn_old;
    end
    cid = 0;
    x_0 = b;
    x_0(I) = x(I);
       if(mfn_old < mfn)   
           countpp = countpp + 1;
           if(countpp <= 50)
            if(sil ~= 1)
                fprintf('Output1: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
            end
                delta = full(max(max(Q(I,I))))/5;
                cid = 1;
                x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                err = log10(max(norm(Q*x+d+s,1),1e-99));
                err_p = log10(max(max(x-b),1e-99));
                x_h = min(x,b);
                mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                if(sil ~= 1)
                    delmf = mfn - mfn_old;
                    fprintf('Output2: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                end
                while((mfn_old <= mfn || err_p < -90) && cid <= 5)
                    if(err_p > -90)
                        delta = cid*delta*n^(1/3);
                    else
                        delta = cid*delta/n^(1/3);
                    end
                    cid = cid + 1;
                    x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                    err = log10(max(norm(Q*x+d+s,1),1e-99));
                    err_p = log10(max(max(x-b),1e-99));
                    x_h = min(x,b);
                    mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                    if(sil ~= 1)
                        delmf = mfn - mfn_old;
                        fprintf('Output3: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                    end
                end
           end
                if(mfn_old <= mfn || err_p < -90)
                    countpp = 0;
                    if(log10(max(max(x_old-b),1e-99)) > -90)
                        %fprintf('First part of safeguard entered. Part infeasible \n');
                        pift = pift + 1;
                        pifu = 1;
                        A(N) = 1;
                        A(x_old<b) = 0;
                        A = find(A>0);
                        A = sort(A);
                        I = ones(n,1);              % compute I, the complement of A
                        I(A) = zeros(length(A),1); 
                        I = find(I>0);              % complement of A
                        I = sort(I);
                        k = k + 1;
                        avg_inact = avg_inact + length(I);
                        delta = 0;
                        Q_act = Q;
                        d_act = d;
                        x = b;                      % x( A) = b( A); 
                        if isempty(I) == 0;          
                             rhs = -d_act(I);
                             if isempty(A) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A)*x(A);   
                             end;
                             x(I) = Q_act(I,I) \  rhs;   % solve for inactive variables	 
                        end
                        x_h = min(x,b);
                        mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                        if(sil ~= 1)
                            delmf = mfn - mfn_old;
                            err = log10(max(norm(Q*x+d+s,1),1e-99));
                            err_p = log10(max(max(x-b),1e-99));
                            fprintf('Output4: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                        end
                        inner_count = 1;
                        err_p = 0;
                        x_0 = b;
                        x_0(I) = x(I);
                        while(mfn_old <= mfn || err_p < -90)
                            pifu = pifu + 1;
                            if(inner_count == 1)
                                IJind = ones(n,1);
                                IJind(b-x_h_old == 0) = 0;
                                IJind = find(IJind > 0);
                                IJind = sort(IJind);
                                emax = max(-1./(b(IJind)-x_h_old(IJind)).*(x_h_old(IJind)-x(IJind)));
                                upper_bound = emax;
                                lower_bound = 0;
                            else
                                if(err_p < -90)
                                    upper_bound = delta; 
                                else
                                    lower_bound = delta;
                                end 
                            end
                            inner_count = inner_count + 1;
                            delta = (upper_bound+lower_bound)/2;
                            x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                            x_h = min(x,b);
                            mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                            err_p = log10(max(max(x-b),1e-99));
                            if(sil ~= 1)
                                delmf = mfn - mfn_old;
                                err = log10(max(norm(Q*x+d+s,1),1e-99));
                                fprintf('Output5: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.10f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                            end
                        end
                        mpifu = max(mpifu,pifu);
                        apifu = apifu + pifu;
                    else
                        %fprintf('Second part of safeguard entered. Part feasible \n');
                        pft = pft + 1;
                        pfu = 1;
                        [dummy,help] = min(s_old);
                        A = setdiff(Apre,help);
                        I = [Ipre;help];
                        I = sort(I);
                        k = k + 1;
                        avg_inact = avg_inact + length(I);
                        delta = 0;
                        Q_act = Q;
                        d_act = d;
                        x = b;                      % x( A) = b( A); 
                        if isempty(I) == 0;          
                             rhs = -d_act(I);
                             if isempty(A) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A)*x(A);   
                             end; 	   
                             x(I) = Q(I,I) \  rhs;   % solve for inactive variables	 
                        end
                        x_h = min(x,b);
                        mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                        err_p = log10(max(max(x-b),1e-99));
                        if(sil ~= 1)
                            delmf = mfn - mfn_old;
                            err = log10(max(norm(Q*x+d+s,1),1e-99));
                            fprintf('Output6: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                        end
                        err_p = 0;
                        inner_count = 1;
                        x_0 = b;
                        x_0(I) = x(I);
                        while(mfn_old <= mfn || err_p < -90)
                            pfu = pfu + 1;
                            if(inner_count == 1)
                                IJind = ones(n,1);
                                IJind(b-x_h_old == 0) = 0;
                                IJind = find(IJind > 0);
                                IJind = sort(IJind);
                                emax = max(-1./(b(IJind)-x_h_old(IJind)).*(x_h_old(IJind)-x(IJind)));
                                upper_bound = emax;
                                lower_bound = 0;
                            else
                                if(err_p < -90)
                                    upper_bound = delta; 
                                else
                                    lower_bound = delta;
                                end 
                            end
                            inner_count = inner_count + 1;
                            delta = (upper_bound+lower_bound)/2;
                            x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                            err_p = log10(max(max(x-b),1e-99));
                            x_h = min(x,b);
                            mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                            if(sil ~= 1)
                                delmf = mfn - mfn_old;
                                err = log10(max(norm(Q*x+d+s,1),1e-99));
                                fprintf('Output7: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta]);
                            end      
                        end 
                        mpfu = max(mpfu,pfu);
                        apfu = apfu + pfu;
                    end
                end
       else
           countpp = 0;
       end
       mcountpp = max(countpp,mcountpp);
       if(sil ~= 1)
           delmf = mfn - mfn_old;
       end
       
        uds = uds + cid + 1;
        s = zeros(n,1);            % s( I) = 0
        kd = kd + 1;
        if isempty(A) == 0;            % backsubsitute for s(A), if |A|>0 
            s(A) = -d(A) - Q(A,:)*x;
            sum_act = sum_act + length(A);
        end;
        err_p = log10(max(max(x-b),1e-99));
        err_d = log10(max(-min(s),1e-99));
        err = log10(max(norm(Q*x+d+s,1),1e-99));
        Apre = A;
        Ipre = I;
        s_old = s;
        delta = 0;  
        if(sil ~= 1)
            fprintf('Output8: %3.0d %6.0f %10.2f %10.2f %10.2f    %+2.2e     %10.2f   %6.0f \n',[k  (n-length(A))  err_p   err_d   err   delmf    delta    countpp]);
        end
        A = zeros(n,1);
        A(N) = 1;
        A(s<0) = 0;
        A(x<b) = 0;
        A = find(A>0);
        A = sort(A);
        Q_act = Q;
        d_act = d;
    
  
    

        done = max(x-b)<=tol & min(s)>= -tol; 
        
     if k >= 5000; done = 1;       % emergency exit to avoid cycling
         fprintf('max number of iterations reached. \n');
     end;
end;                 % end while
 

time = toc;
Aopt = A;
Iopt = I;
if(sil ~= 1)
optobj = 0.5*x'*Q*x+d'*x;
fprintf('The optimal objective value is %+2.2e. \n', optobj); 
fprintf('%4.3f seconds needed to find the optimal objecitve value.  \n', time);
end
if(k == 0)
    uds = 0;
else
    uds = uds/k;
end
if(cA == 1)
    avg_inact = avg_inact/(k+1);
else
    avg_inact = avg_inact/k;
end








